
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class App_installationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_installations = await db.app_installations.create(
            {
                id: data.id || undefined,
        
        installation_status: data.installation_status
        ||
        null
            ,
            
        installed_at: data.installed_at
        ||
        null
            ,
            
        disabled_at: data.disabled_at
        ||
        null
            ,
            
        disable_reason: data.disable_reason
        ||
        null
            ,
            
        auto_suggest_enabled: data.auto_suggest_enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await app_installations.setMarketplace_app( data.marketplace_app || null, {
            transaction,
        });
        
        await app_installations.setTeam( data.team || null, {
            transaction,
        });
        
        await app_installations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return app_installations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const app_installationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                installation_status: item.installation_status
            ||
            null
            ,
            
                installed_at: item.installed_at
            ||
            null
            ,
            
                disabled_at: item.disabled_at
            ||
            null
            ,
            
                disable_reason: item.disable_reason
            ||
            null
            ,
            
                auto_suggest_enabled: item.auto_suggest_enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const app_installations = await db.app_installations.bulkCreate(app_installationsData, { transaction });

        // For each item created, replace relation files
        

        return app_installations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const app_installations = await db.app_installations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.installation_status !== undefined) updatePayload.installation_status = data.installation_status;
        
        
        if (data.installed_at !== undefined) updatePayload.installed_at = data.installed_at;
        
        
        if (data.disabled_at !== undefined) updatePayload.disabled_at = data.disabled_at;
        
        
        if (data.disable_reason !== undefined) updatePayload.disable_reason = data.disable_reason;
        
        
        if (data.auto_suggest_enabled !== undefined) updatePayload.auto_suggest_enabled = data.auto_suggest_enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await app_installations.update(updatePayload, {transaction});

        
        
        if (data.marketplace_app !== undefined) {
            await app_installations.setMarketplace_app(
              
              data.marketplace_app,
              
              { transaction }
            );
        }
        
        if (data.team !== undefined) {
            await app_installations.setTeam(
              
              data.team,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await app_installations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return app_installations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_installations = await db.app_installations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of app_installations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of app_installations) {
                await record.destroy({transaction});
            }
        });


        return app_installations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const app_installations = await db.app_installations.findByPk(id, options);

        await app_installations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await app_installations.destroy({
            transaction
        });

        return app_installations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const app_installations = await db.app_installations.findOne(
            { where },
            { transaction },
        );

        if (!app_installations) {
            return app_installations;
        }

        const output = app_installations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.marketplace_app = await app_installations.getMarketplace_app({
            transaction
        });
        
        
        output.team = await app_installations.getTeam({
            transaction
        });
        
        
        output.organizations = await app_installations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.marketplace_apps,
        as: 'marketplace_app',
        
        where: filter.marketplace_app ? {
          [Op.or]: [
            { id: { [Op.in]: filter.marketplace_app.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.marketplace_app.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.teams,
        as: 'team',
        
        where: filter.team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.team.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.disable_reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_installations',
                        'disable_reason',
                        filter.disable_reason,
                    ),
                };
            }
            

            
            

            
            if (filter.installed_atRange) {
                const [start, end] = filter.installed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    installed_at: {
                    ...where.installed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    installed_at: {
                    ...where.installed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.disabled_atRange) {
                const [start, end] = filter.disabled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    disabled_at: {
                    ...where.disabled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    disabled_at: {
                    ...where.disabled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.installation_status) {
                where = {
                    ...where,
                installation_status: filter.installation_status,
            };
            }
            
            if (filter.auto_suggest_enabled) {
                where = {
                    ...where,
                auto_suggest_enabled: filter.auto_suggest_enabled,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.app_installations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'app_installations',
                        'installation_status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.app_installations.findAll({
            attributes: [ 'id', 'installation_status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['installation_status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.installation_status,
        }));
    }

    
};

